#include <stdio.h>
#include <stdlib.h>

#include "f2c.h"

 int main(void)
{
    /* Builtin functions */
    double cos(double), sin(double);
    /* Local variables */
    extern /* Subroutine */ int f_c();
    static double h__;
    static int m, n;
    static double q, y[2], h0;
    static int k0;
    static double x1, ay[28] /* was [2][14] */, dy[2], xk, xn, yn[2];
    static int nx;
    static double xs[5], yt[2];
    static double rab[457], ady[26] /* was [2][13] */, dyn[2], dyt[2],
	         ad2y[24] /* was [2][12] */;
    int de88d_c( );
    static double dely[2];
    static int imax;
    static double deldy[2];
    static int iordy, iniapr;

    m = 2;
    q = .5;
    xn = 0.f;
    yn[0] = cos(q) + 3.;
    yn[1] = -sin(q) + 2.;
    dyn[0] = q * 2. * sin(q);
    dyn[1] = q * 2. * cos(q);
    xk = 1.;
    iordy = 2;
    h0 = 1.;
    x1 = xk * 2. - 1.;
    yt[0] = cos(q * x1) + 3.;
    yt[1] = sin(q * x1) + 2.;
    dyt[0] = q * -2. * sin(q * x1);
    dyt[1] = q * 2. * cos(q * x1);
    k0 = 11;
    imax = 16;
    iniapr = 1;
    h__ = h0;

    de88d_c((U_fp)f_c, &m, &xn, yn, dyn, &xk, &k0, &iniapr, &imax, &iordy, &h__,
	     y, dy, &nx, xs, ay, ady, ad2y, rab);

    dely[0] = yt[0] - y[0];
    dely[1] = yt[1] - y[1];
    deldy[0] = dyt[0] - dy[0];
    deldy[1] = dyt[1] - dy[1];

    printf("\n ------------------------------------------------------------\n");
    printf("\n nx=%3i  xs=\n", nx);
    printf("\n %21.14e %21.14e \n\n", xs[0], xs[1]);

    printf("\n h0=%21.14e k0=%3i iniapr= %1i imax=%3i iordy=%1i \n\n",h0,k0,iniapr,imax, iordy);

    printf("\n y= %21.14e %21.14e\n",y[0],y[1]);
    printf("\n yt=%21.14e %21.14e\n",yt[0],yt[1]);
    printf("\n dely= %23.14e %23.14e \n\n", dely[0], dely[1]);

    printf("\n dy= %21.14e %21.14e\n",dy[0],dy[1]);
    printf("\n dyt= %21.14e %21.14e\n",dyt[0],dyt[1]);
    printf("\n deldy= %23.14e %23.14e \n", deldy[0], deldy[1]);

    printf("\n\n                    COEFFICIENTS AY, ADY AND AD2Y ON 1 SEGMENT \n");
    printf("\n                            Chebyshev coefficients \n");
    printf("\n              for Y                   for  Y'                for Y'' \n");
    printf("\n   FOR 1 COMPONENT\n");

    for (n = 0; n <= 22;  n+=2) {
         printf("\n %3i %23.14e %23.14e %23.14e", n/2, ay[n], ady[n], ad2y[n]);
    }
    printf("\n %3i %23.14e %23.14e", 24/2, ay[24], ady[24]);
    printf("\n %3i %23.14e \n", 26/2, ay[26]);

    printf("\n                             Chebyshev coefficients \n");
    printf("\n              for Y                   for  Y'                for Y'' \n");
    printf("\n   FOR 2 COMPONENT\n");

    for (n = 1; n <= 23;  n+=2) {
         printf("\n %3i %23.14e %23.14e %23.14e", n/2, ay[n], ady[n], ad2y[n]);
    }
    printf("\n %3i %23.14e %23.14e", 24/2, ay[25], ady[25]);
    printf("\n %3i %23.14e \n", 26/2, ay[27]);
    return 0;
} /* main */


/* Subroutine */ int f_c(double *x, double *y, double *dy,
	double *z__, int *m)
{
    /* System generated locals */
    double d__1;

    /* Builtin functions */
    double exp(double);

    /* Local variables */
    static real q;

    /* Parameter adjustments */
    --z__;
    --dy;
    --y;

    /* Function Body */
    q = .5f;
/* Computing 2nd power */
    d__1 = (1. - exp(3. - y[1] + dy[2] * .5 / q)) / (*x + 1.);
    z__[1] = q * -2. * dy[2] - d__1 * d__1;
/* Computing 2nd power */
    d__1 = dy[2] - q * 2. * (y[1] - 3.);
    z__[2] = q * 2. * dy[1] - d__1 * d__1;
    return 0;
} /* f_c */
